﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using Telerik.Windows.Controls;

namespace SLApp
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            Thread.CurrentThread.CurrentCulture = System.Globalization.CultureInfo.InvariantCulture;
            InitializeComponent();
        }

        public DateTime SelectionStart
        {
        	get
        	{
                return this.timeBar.SelectionStart;
        	}
        }

        public DateTime SelectionEnd
        {
            get
            {
                return this.timeBar.SelectionEnd;
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            TimeSpan selectedRange = this.SelectionEnd - this.SelectionStart;
        }
    }

    public class TimeBarViewModel : ViewModelBase
    {
        
        #region TimeBarProperties

        private DateTime periodStart;
        
        public DateTime PeriodStart
        {
            get
            {
                return periodStart;
            }
            set
            {
                if (periodStart == value)
                    return;
                
                periodStart = value;
                this.OnPropertyChanged("PeriodStart");
            }
        }
 
        private DateTime periodEnd;
        
        public DateTime PeriodEnd
        {
            get
            {
                return periodEnd;
            }
            set
            {
                if (periodEnd == value)
                    return;
                
                periodEnd = value;
                this.OnPropertyChanged("PeriodEnd");
            }
        }
 
        private DateTime visiblePeriodStart;
        
        public DateTime VisiblePeriodStart
        {
            get
            {
                return visiblePeriodStart;
            }
            set
            {
                if (visiblePeriodStart == value)
                    return;
                
                visiblePeriodStart = value;
                this.OnPropertyChanged("VisiblePeriodStart");
            }
        }
 
        private DateTime visiblePeriodEnd;
        
        public DateTime VisiblePeriodEnd
        {
            get
            {
                return visiblePeriodEnd;
            }
            set
            {
                if (visiblePeriodEnd == value)
                    return;
                
                visiblePeriodEnd = value;
                this.OnPropertyChanged("VisiblePeriodEnd");
            }
        }
 
        private DateTime selectionStart;
        
        public DateTime SelectionStart
        {
            get
            {
                return selectionStart;
            }
            set
            {
                if (selectionStart == value)
                    return;
                
                selectionStart = value;
                this.OnPropertyChanged("SelectionStart");
            }
        }
 
        private DateTime selectionEnd;
        
        public DateTime SelectionEnd
        {
            get
            {
                return selectionEnd;
            }
            set
            {
                if (selectionEnd == value)
                    return;
                
                selectionEnd = value;
                this.OnPropertyChanged("SelectionEnd");
            }
        }

        private TimeSpan maxSelectionRange;

        public TimeSpan MaxSelectionRange
        {
            get
            {
                return maxSelectionRange;
            }
            set
            {
                if (maxSelectionRange == value)
                    return;
 
                maxSelectionRange = value;
                this.OnPropertyChanged("MaxSelectionRange");
            }
        }

        #endregion
        
        public TimeBarViewModel()
        {
            this.periodStart = new DateTime(2013, 1, 1);
            this.periodEnd = new DateTime(2018, 1, 1);
            this.visiblePeriodStart = new DateTime(2013, 3, 1);
            this.visiblePeriodEnd = new DateTime(2013, 8, 1);
            this.selectionStart = new DateTime(2013, 5, 1);
            this.selectionEnd = new DateTime(2013, 5, 15);
            this.maxSelectionRange = new TimeSpan(31, 0, 0, 0);
        }
    }
}
